# aur_json
# Query the Arch User Repository Remote Procedure Call Interface
# https://wiki.archlinux.org/index.php/AurJson
# Copyright (c) 2013 Boohbah <boohbah at gmail.com>

require File.expand_path('../aur_json/version.rb', __FILE__)
require 'net/http'
require 'json'

module AurJson
  class Query
    attr_reader :result

    def initialize type, arg
      unless %w(search msearch info multiinfo).include? type
        raise "ERROR: Unknown query type #{type}"
      end

      # The rpc.php script on the server will handle other errors
      base = "https://aur.archlinux.org/rpc.php?type="
      uri = URI("#{base}#{type}&arg=#{arg}")

      Net::HTTP.start(uri.host, uri.port,
        :use_ssl => uri.scheme == 'https') do |http|
        request = Net::HTTP::Get.new uri
        response = http.request request
        @result = JSON.parse response.body
      end
    end
  end
end
